<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:lx="scpf.org:lexicon" exclude-result-prefixes="sc sp lx">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" omit-xml-declaration="yes"/>
	<xsl:param name="vDialog"/>
	<xsl:param name="vAgent"/>
	<xsl:template match="*">
		<xsl:if test="sp:license">
			<span class="legalInfo">
				<xsl:apply-templates select="sp:license"/>
			</span>
		</xsl:if>
	</xsl:template>
	<xsl:template match="sp:license">
		<xsl:variable name="vLicLang" select="'en'"/>
		<xsl:variable name="vLicTitle">
			<xsl:choose>
				<xsl:when test="string(.)='zero'">Creative Commons Zero</xsl:when>
				<xsl:when test="string(.)='by'">Attribution</xsl:when>
				<xsl:when test="string(.)='by-nc'">Attribution – Non commercial</xsl:when>
				<xsl:when test="string(.)='by-nc-nd'">Attribution – Non commercial - No Derivative Work</xsl:when>
				<xsl:when test="string(.)='by-nc-sa'">Attribution – Non commercial - Share Alike</xsl:when>
				<xsl:when test="string(.)='by-nd'">Attribution - No Derivative Work</xsl:when>
				<xsl:when test="string(.)='by-sa'">Attribution - Share Alike</xsl:when>
				<xsl:when test="string(.)='gnu-fdl'">GNU Free Documentation licence (GFDL)</xsl:when>
				<xsl:otherwise>Public Domain licence</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="vLicUrl">
			<xsl:choose>
				<xsl:when test="string(.)='gnu-fdl'">http://www.gnu.org/licenses/fdl.html</xsl:when>
				<xsl:when test="string(.)='publicdomain' or string(.)='zero'">http://creativecommons.org/licenses/<xsl:value-of select="."/>/1.0/deed.<xsl:value-of select="$vLicLang"/>
				</xsl:when>
				<xsl:otherwise>http://creativecommons.org/licenses/<xsl:value-of select="."/>/3.0/deed.<xsl:value-of select="$vLicLang"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<a rel="license" href="{$vLicUrl}" target="_blank" class="cc-button" title="{$vLicTitle} (new window)">
			<img alt="{$vLicTitle}" width="80" height="15" src="../skin/img/lic/{.}.png"/>
		</a>
	</xsl:template>
</xsl:stylesheet>