<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:java="http://xml.apache.org/xslt/java" xmlns:lx="scpf.org:lexicon" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" exclude-result-prefixes="java lx sp " >

<xsl:param name="vSrcNode"/>

<xsl:template match="text()|@*"/>
<xsl:template match="*[@sc:refUri]">
<attrRef nm="?" refUri="{@sc:refUri}"/>
</xsl:template>

<xsl:template match="/sc:item">
<xsl:apply-templates select="lx:term"/>
</xsl:template>

<xsl:template match="sc:item/lx:term">
	<title><xsl:for-each xmlns:xsl="http://www.w3.org/1999/XSL/Transform" select="lx:termM"><xsl:value-of select="sp:name"/></xsl:for-each></title>
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>


<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="lx:term/sp:pronunciation[@sc:refUri]">
<attrRef refUri="{@sc:refUri}" nm="lx_term:pronunciation"/>
<xsl:apply-templates/>
</xsl:template>
			
		
			
			
		
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="lx:index/sp:tag[@sc:refUri]">
<attrRef refUri="{@sc:refUri}" nm="lx_index:tag"/>
<xsl:apply-templates/>
</xsl:template>
		
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="lx:definition/sp:source[@sc:refUri]">
<attrRef refUri="{@sc:refUri}" nm="lx_definition:source"/>
<xsl:apply-templates/>
</xsl:template>
			
			
		
			
				
				
				
			
		
		
			
			
				
			
			
				
			
			
				
				
				
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:row[ancestor::sc:table[1]/@role=''][@role=''][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:defTxt]">
<xsl:apply-templates/>
</xsl:template>
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:row[ancestor::sc:table[1]/@role=''][@role='head'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:defTxt]">
<xsl:apply-templates/>
</xsl:template>
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:row[ancestor::sc:table[1]/@role=''][@role='total'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:defTxt]">
<xsl:apply-templates/>
</xsl:template>
				
				
				
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:extBlock[@role='img'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:defTxt]">
<attrRef refUri="{@sc:refUri}" nm="lx_defTxt:extBlockTag:img"/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:extBlock[@role='illus'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:defTxt]">
<attrRef refUri="{@sc:refUri}" nm="lx_defTxt:extBlockTag:illus"/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:extBlock[@role='anim'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:defTxt]">
<attrRef refUri="{@sc:refUri}" nm="lx_defTxt:extBlockTag:anim"/>
</xsl:template>
		
		
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='lnkTerm'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:defTxt]">
<attrRef refUri="{@sc:refUri}" nm="lx_defTxt:uLinkTag:lnkTerm"/>
<xsl:apply-templates/>
</xsl:template>
			
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='ref'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:defTxt]">
<attrRef refUri="{@sc:refUri}" nm="lx_defTxt:uLinkTag:ref"/>
<xsl:apply-templates/>
</xsl:template>
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:phrase[@role='url'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:defTxt]">
<xsl:apply-templates/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:phrase[@role='quote'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:defTxt]">
<xsl:apply-templates/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:phrase[@role='special'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:defTxt]">
<xsl:apply-templates/>
</xsl:template>
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:inlineImg[@role='ico'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:defTxt]">
<attrRef refUri="{@sc:refUri}" nm="lx_defTxt:inlineImgTag:ico"/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:inlineImg[@role='icoIllus'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:defTxt]">
<attrRef refUri="{@sc:refUri}" nm="lx_defTxt:inlineImgTag:icoIllus"/>
</xsl:template>
		
	<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="lx:defTxt">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="lx:urlM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
			
		
			
			
		
			
			
				
				
			
			
				
				
			
			
				
				
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="lx:langM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
		
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="lx:sourceM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
			
		
			
			
		
			
			
		
		
			
			
				
			
			
				
			
		
		
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:phrase[@role='quote'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:sTxt]">
<xsl:apply-templates/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:phrase[@role='special'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:sTxt]">
<xsl:apply-templates/>
</xsl:template>
			
		
	<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="lx:sTxt">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>

		
			
			
				
			
			
				
			
			
				
				
				
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:row[ancestor::sc:table[1]/@role=''][@role=''][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:txt]">
<xsl:apply-templates/>
</xsl:template>
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:row[ancestor::sc:table[1]/@role=''][@role='head'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:txt]">
<xsl:apply-templates/>
</xsl:template>
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:row[ancestor::sc:table[1]/@role=''][@role='total'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:txt]">
<xsl:apply-templates/>
</xsl:template>
				
				
				
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:extBlock[@role='img'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:txt]">
<attrRef refUri="{@sc:refUri}" nm="lx_txt:extBlockTag:img"/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:extBlock[@role='illus'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:txt]">
<attrRef refUri="{@sc:refUri}" nm="lx_txt:extBlockTag:illus"/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:extBlock[@role='anim'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:txt]">
<attrRef refUri="{@sc:refUri}" nm="lx_txt:extBlockTag:anim"/>
</xsl:template>
		
		
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='ref'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:txt]">
<attrRef refUri="{@sc:refUri}" nm="lx_txt:uLinkTag:ref"/>
<xsl:apply-templates/>
</xsl:template>
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:phrase[@role='url'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:txt]">
<xsl:apply-templates/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:phrase[@role='quote'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:txt]">
<xsl:apply-templates/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:phrase[@role='special'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:txt]">
<xsl:apply-templates/>
</xsl:template>
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:inlineImg[@role='ico'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:txt]">
<attrRef refUri="{@sc:refUri}" nm="lx_txt:inlineImgTag:ico"/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:inlineImg[@role='icoIllus'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::lx:txt]">
<attrRef refUri="{@sc:refUri}" nm="lx_txt:inlineImgTag:icoIllus"/>
</xsl:template>
		
	<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="lx:txt">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="lx:linkTermM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="lx:linkTermM/sp:synG/sp:synonymous[@sc:refUri]">
<attrRef refUri="{@sc:refUri}" nm="lx_linkTermM:synG:synonymous:"/>
</xsl:template>
			
		
			
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="lx:linkTermM/sp:antonymG/sp:antonym[@sc:refUri]">
<attrRef refUri="{@sc:refUri}" nm="lx_linkTermM:antonymG:antonym:"/>
</xsl:template>
			
		
			
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="lx:linkTermM/sp:isGroup/sp:is[@sc:refUri]">
<attrRef refUri="{@sc:refUri}" nm="lx_linkTermM:isGroup:is:"/>
</xsl:template>
			
		
			
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="lx:linkTermM/sp:partOfGroup/sp:partOf[@sc:refUri]">
<attrRef refUri="{@sc:refUri}" nm="lx_linkTermM:partOfGroup:partOf:"/>
</xsl:template>
			
		
			
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="lx:linkTermM/sp:seeAlsoGroup/sp:seeAlso[@sc:refUri]">
<attrRef refUri="{@sc:refUri}" nm="lx_linkTermM:seeAlsoGroup:seeAlso:"/>
</xsl:template>
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="lx:moreInfoM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="lx:termM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
			
			
		
			
			
				
				
				
				
			
		
			
			
				
				
				
				
			
		
			
			
				
				
					
					
				
				
					
					
						
						
						
						
						
						
					
				
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="lx:pronunciationM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
			
		

</xsl:stylesheet>