var categoryMgr = {
	fPathRoot : "",
	fCatBtns : [],
	fStrings : ["Recherche par catégories","",
	/*02*/      "Voir la recherche par catégories","Masquer la recherche par catégories",
	/*04*/      "Catégories", " Cliquez pour sélectionnez/désélectionnez"],


/* === Public functions ===================================================== */
	init : function (pPathRoot){
		scCoLib.util.log("categoryMgr.init");
		if (typeof pPathRoot != "undefined") this.fPathRoot = pPathRoot;
		scOnLoads.push(this);
	},

	onLoad : function(){
		scCoLib.util.log("categoryMgr.onLoad");
		try{
			var vMnu = this.xBuildFilters(lexiconMgr.fLexiconJson, searchMgr.fSearchForm);
			if(!vMnu) return;

			var vAdvSearchBtn = this.xAddBtn(searchMgr.fSearchForm,"advSearchBtn", this.fStrings[0], this.fStrings[2]), vFilters = "";
			vAdvSearchBtn.href = "#";
			vAdvSearchBtn.mnu = vMnu;
			vAdvSearchBtn.mnu.toggleState = false;
			vAdvSearchBtn.onclick = this.sToggleMnu;

			for (var i = 0; i < this.fCatBtns.length; i++) {
				var vSchFilter = this.fCatBtns[i], vSchFilterVal = vSchFilter.getAttribute("data-val");
				vFilters += vSchFilterVal + " ";
				if(tplMgr.fStore.get(vSchFilterVal)=="true") {
					vSchFilter.checked=true;
					vSchFilter.setAttribute("data-ison",true);
					searchMgr.fFilter = true;
				}
			}
			if(searchMgr.fFilter == true) vAdvSearchBtn.click();
			tplMgr.fStore.set("filters",vFilters);
		} catch(e){
			scCoLib.util.log("ERROR - categoryMgr.onLoad: "+e);
		}
	},

/* === Callback functions =================================================== */
	/** categoryMgr.sShowFilter : Filter callback : called on search a successful. */
	sShowFilter: function(){
		if(this.checked) {
			if (this.fIsRadio){
				for (var i=0; i<this.fIdxGrp.length; i++) {
					this.fIdxGrp[i].checked = false;
					this.fIdxGrp[i].setAttribute("data-ison",false);
				}
				this.checked = true;
			}
			this.setAttribute("data-ison",true);
		}
		else this.setAttribute("data-ison",false);
		searchMgr.findFilters();
		searchMgr.find();
	},
	/** categoryMgr.sToggleMnu. */
	sToggleMnu: function(){
		if(!this) return;
		var vState = this.mnu.toggleState;
		vState = vState?false:true;
		// this.title = vState?categoryMgr.fStrings[3]:categoryMgr.fStrings[2];
		categoryMgr.xSwitchClass(this.mnu, vState?"display_off":"display_on", vState?"display_on":"display_off", true);
		this.mnu.toggleState = vState;
		if(!vState) categoryMgr.xReset();
		return false;
	},

/* === Private functions ==================================================== */
	xReset : function() {
		for (var i = 0; i < this.fCatBtns.length; i++) {
			var vSchFilter = this.fCatBtns[i];
			vSchFilter.checked=false;
			vSchFilter.setAttribute("data-ison",false);
		}
		searchMgr.fFilter = false;
		searchMgr.findFilters();
		searchMgr.find();
	},

	xBuildFilters : function(pLexicon,pRoot) {
		//scCoLib.util.log("categoryMgr.buildFilters");
		if(!pLexicon || pLexicon.tags.length == 1 || !pRoot) return;
		pLexicon.tags.sort(function (a, b) {
			if (!a || !b) return 0;
			if (a.value > b.value) return 1;
			if (a.value < b.value) return -1;
			return 0;
		});
		var vFilterContainer = scDynUiMgr.addElement("div",pRoot,"lxc_filters_container"),
		vFilterRoot = scDynUiMgr.addElement("div",vFilterContainer,"lxc_filters_bk display_off"),
		vFilterFieldSet = scDynUiMgr.addElement("fieldset",vFilterRoot,"lxc_filters_fields"),
		vFilterLegend = scDynUiMgr.addElement("legend",vFilterFieldSet),
		vIdxGrps = {};
		vFilterLegend.innerHTML = this.fStrings[4];
		for (var i = 0; i < pLexicon.tags.length-1; i++) {
			var vChi = pLexicon.tags[i],
			vFilterDiv = scDynUiMgr.addElement("div",vFilterFieldSet,"lxc_filters_div"),
			vFilterInput = scDynUiMgr.addElement("input",vFilterDiv,"lxc_filters_input schCrit"),
			vFilterLabel = scDynUiMgr.addElement("label",vFilterDiv,"lxc_filters_label");
			this.fCatBtns.push(vFilterInput);
			vFilterInput.type = "checkbox";
			vFilterInput.name = vChi.value;
			vFilterInput.value = vChi.key;
			vFilterInput.id = vChi.key;
			// vFilterInput.title = this.fStrings[5];
			vFilterLabel.setAttribute("for",vChi.key);
			vFilterLabel.innerHTML = vChi.value;
			vFilterInput.onclick = this.sShowFilter;
			vFilterInput.setAttribute("data-val",vChi.key);
			vFilterInput.setAttribute("data-index",vChi.index);
			vFilterInput.fIsRadio = !scServices.scSearch.hasIntersections(vChi.index);
			if (!vIdxGrps[vChi.index]) vIdxGrps[vChi.index] = [vFilterInput];
			else vIdxGrps[vChi.index].push(vFilterInput);
			vFilterInput.fIdxGrp = vIdxGrps[vChi.index];
		};
		return vFilterRoot;
	},

/* === Utilities =========================================================== */
	/** categoryMgr.xAddBtn : Add a HTML button to a parent node. */
	xAddBtn : function(pParent, pClassName, pCapt, pTitle, pNxtSib) {
		var vBtn = pParent.ownerDocument.createElement("button");
		vBtn.className = pClassName;
		vBtn.fName = pClassName;
		if (pTitle) vBtn.setAttribute("title", pTitle);
		if (pCapt) vBtn.innerHTML = '<span class="capt">' + pCapt + '</span>';
		if (pNxtSib) pParent.insertBefore(vBtn,pNxtSib);
		else pParent.appendChild(vBtn);
		return vBtn;
	},

	/** categoryMgr.xSwitchClass - replace a class name. */
	xSwitchClass : function(pNode, pClassOld, pClassNew, pAddIfAbsent, pMatchExact) {
		var vAddIfAbsent = typeof pAddIfAbsent == "undefined" ? false : pAddIfAbsent;
		var vMatchExact = typeof pMatchExact == "undefined" ? true : pMatchExact;
		var vClassName = pNode.className;
		var vReg = new RegExp("\\b"+pClassNew+"\\b");
		if (vMatchExact && vClassName.match(vReg)) return;
		var vClassFound = false;
		if (pClassOld && pClassOld != "") {
			if (vClassName.indexOf(pClassOld)==-1){
				if (!vAddIfAbsent) return;
				else if (pClassNew && pClassNew != '') pNode.className = vClassName + " " + pClassNew;
			} else {
				var vCurrentClasses = vClassName.split(' ');
				var vNewClasses = new Array();
				for (var i = 0, n = vCurrentClasses.length; i < n; i++) {
					var vCurrentClass = vCurrentClasses[i];
					if (vMatchExact && vCurrentClass != pClassOld || !vMatchExact && vCurrentClass.indexOf(pClassOld) != 0) {
						vNewClasses.push(vCurrentClasses[i]);
					} else {
						if (pClassNew && pClassNew != '') vNewClasses.push(pClassNew);
						vClassFound = true;
					}
				}
				pNode.className = vNewClasses.join(' ');
			}
		}
		return vClassFound;
	},
	loadSortKey : "ZZCategoryMgr",
}
